package entities;

import java.util.*;

/*  
 *  entita, ktora uchovava informacie o jednotlivych klucovych slovach pouzitych v systeme a takisto uchovava aj hierarchicke usporiadanie klucovych slov do stromu
*/
public class KlucoveSlovo {

    /*  
     *  primarny kluc do tabulky
     */
    private Integer id;             
    
    /**
     *  nazov klucoveho slova
     */
    private String nazov;
    
    /**
     *  zadefinovanie, ktore klucove slovo je predchodcom (rodicom)
     */
    private KlucoveSlovo predchodca;
    
    /**
     *  zoznam Klucovzch slov, ktore su priamymi potomkami daneho klucoveho slova
     */
    private Set<KlucoveSlovo> nasledovnici = new LinkedHashSet<KlucoveSlovo>();
    
    /**
     *  zoznam odkazov na objekty z triedy PredmetKlucoveslovo, ktore su zviazane s danym objektom
     */
    private Set<PredmetKlucoveslovo> zdrojeOhodnotenia = new HashSet<PredmetKlucoveslovo>(0);
    
    /**
     *  odkaz na ohodnotenia pouzivatelov, ktori maju dane kluvoce slovo ohodnotene (hodnotenie je vacsie od nuly)
     */
    private Set<OhodnotenieKSPreStudenta> OhodnotenieStudenta = new HashSet<OhodnotenieKSPreStudenta>(0);

    public KlucoveSlovo() {
    }

    public KlucoveSlovo(String nazov, KlucoveSlovo predchodca) {
        this.setNazov(nazov);
        if (predchodca != null) {
            this.setPredchodca(predchodca);
        } else {
            this.setPredchodca(this);
        }
    }

    public String getNazov() {
        return nazov;
    }

    public void setNazov(String nazov) {
        this.nazov = nazov;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public KlucoveSlovo getPredchodca() {
        return predchodca;
    }

    public void setPredchodca(KlucoveSlovo predchodca) {
        this.predchodca = predchodca;
    }

    public Set<KlucoveSlovo> getNasledovnici() {
        return nasledovnici;
    }

    public void setNasledovnici(Set<KlucoveSlovo> nasledovnici) {
        this.nasledovnici = nasledovnici;
    }

    public Set<PredmetKlucoveslovo> getZdrojeOhodnotenia() {
        return zdrojeOhodnotenia;
    }

    public void setZdrojeOhodnotenia(Set<PredmetKlucoveslovo> zdrojeOhodnotenia) {
        this.zdrojeOhodnotenia = zdrojeOhodnotenia;
    }

    public Set<OhodnotenieKSPreStudenta> getOhodnotenieStudenta() {
        return OhodnotenieStudenta;
    }

    public void setOhodnotenieStudenta(Set<OhodnotenieKSPreStudenta> OhodnotenieStudenta) {
        this.OhodnotenieStudenta = OhodnotenieStudenta;
    }

    @Override
    public String toString() {
        return this.getNazov();
    }
}
