package entities;

import entities.Pouzivatel;

/*  
 *  entita, ktora uchovava informacie o celkovom ohodnoteni klucoveho slova pre daneho studenta. Na toto ohodnotenie vplyvaju hodnotenia predmetov, ktore student absolvoval, dalej sebahodnotenia, ktore si student vyplnil a hodnotenia, ktore vyplnili pedagogovia o studentovi
*/
public class OhodnotenieKSPreStudenta {
    /*  
     *  primarny kluc do tabulky
     */
    private Integer id;
    
    /*  
     *  vypocitane ohodnotenie klucoveho slova daneho studenta
     */
    private Double ohodnotenie;
    
    /*  
     *  identifikator studenta, ktoremu patri ohodnotenie
     */
    private Pouzivatel St;
    
    /*  
     *  identifikator klucoveho slova, ktore je pre daneho studenta hodnotene
     */
    private KlucoveSlovo Ks;
    
    /*  
     *  pocet zdrojov, ktore prispeli k danemu ohodnoteniu
     */
    private Integer pocetZdrojov;
    
    /** Creates a new instance of HodnoteniePredmetu */
    public OhodnotenieKSPreStudenta() {
    }
    
    public OhodnotenieKSPreStudenta(Double ohodnotenie, Pouzivatel s, KlucoveSlovo Ks, Integer pocet) {
        this.setOhodnotenie(ohodnotenie);
        this.setSt(s);
        this.setKs(Ks);
        this.setPocetZdrojov(pocet);
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Double getOhodnotenie() {
        return ohodnotenie;
    }

    public void setOhodnotenie(Double ohodnotenie) {
        this.ohodnotenie = ohodnotenie;
    }

    public Pouzivatel getSt() {
        return St;
    }

    public void setSt(Pouzivatel St) {
        this.St = St;
    }

    public KlucoveSlovo getKs() {
        return Ks;
    }

    public void setKs(KlucoveSlovo Ks) {
        this.Ks = Ks;
    }

    public Integer getPocetZdrojov() {
        return pocetZdrojov;
    }

    public void setPocetZdrojov(Integer pocetZdrojov) {
        this.pocetZdrojov = pocetZdrojov;
    }
 
   
    
}
