package entities;

import java.util.HashSet;
import java.util.Set;

/*  
 *  entita, uchovavajuca informacie o pouzivateloch. Informacie o studentoch a pedagogoch su importovane z externej databazy AIS.
*/
public class Pouzivatel {
    
    /*  
     *  primarny kluc do tabulky
     */
    private Integer id;     
    
    /*  
     *  krstne meno pouzivatela
     */
    private String meno;
    
    /*  
     *  priezvosko pouzivatela
     */
    private String priezvisko;
    
    /*  
     *  prihlasovacie meno pouzivatela do systemu Bzz
     */
    private String login;
    
    /*  
     *  prihlasovacie heslo pouzivatela do systemu Bzz
     */
    private String passwd;
    
    /*  
     *  identifikator pouzivatela - 1:student, 2:pedagog, 3:administrator, 4:guest
     */
    private Integer typPouzivatela;
    
    /*  
     *  emailova adresa pouzivatela
     */
    private String email;
    
    /*  
     *  postoj pouzivatela k zverejnovaniu jeho emailovej adresy
     */
    private Boolean emailSuhlas;
    
    /*  
     *  ak je pouzivatelom student, tak tu su odkazy na ohodnotenie klucovych slov daneho studenta
     */
    private Set<OhodnotenieKSPreStudenta> ohodnotenieStudenta = new HashSet<OhodnotenieKSPreStudenta>(0);   // hodnotenie studenta pre dane vsetky klucove slova, ktore sa ho tykaju (alebo pre vsetky ?? )
    
    /*  
     *  ak je pouzivatelom student, tak tu su odkazy na sebahodnotenia, ktre si student vyplnil
     */
    private Set<SebahodnotenieStudenta> sebahodnotenie = new HashSet<SebahodnotenieStudenta>(0);   // hodnotenie studenta pre dane vsetky klucove slova, ktore sa ho tykaju (alebo pre vsetky ?? )
    
    /*  
     *  ak je pouzivatelom student, tak tu su odkazy na hodnotenia, ktore pre daneho studenta vyplnili pedagogovia
     */
    private Set<pedagogHodnotenieStudenta> pedagogHodnotenie = new HashSet<pedagogHodnotenieStudenta>(0);   // hodnotenie studenta pre dane vsetky klucove slova, ktore sa ho tykaju (alebo pre vsetky ?? ) 
    
    /*  
     *  premenna, v ktorej sa pocas vyhladavania podla klucovych slov uchovava priebezne vypocitane celkove hodnotenie v ramci hladania
     */
    private double searchResult;
    
    // no-arg cons
    public Pouzivatel() {
    }
    
    // cons
    public Pouzivatel(int id, String meno, String priezvisko, String login, String passwd, int typ,String email, Boolean suhlas) {
        this.id=id;
        this.setMeno(meno);
        this.setPriezvisko(priezvisko);
        this.setLogin(login);
        this.setPasswd(passwd);
        this.setTypPouzivatela(typ);
        this.setEmail(email);
        this.setEmailSuhlas(suhlas);
    }
            
        
    
    
    public Integer getId() {
        return id;
    }
    
    public void setId(Integer id) {
        this.id = id;
    }
    
    public String getMeno() {
        return meno;
    }
    
    public void setMeno(String meno) {
        this.meno = meno;
    }
    
    public String getPriezvisko() {
        return priezvisko;
    }
    
    public void setPriezvisko(String priezvisko) {
        this.priezvisko = priezvisko;
    }
    
    public String getLogin() {
        return login;
    }
    
    public void setLogin(String login) {
        this.login = login;
    }
    
    public String getPasswd() {
        return passwd;
    }
    
    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

    
    public Set<OhodnotenieKSPreStudenta> getOhodnotenieStudenta() {
        return ohodnotenieStudenta;
    }
    
    public void setOhodnotenieStudenta(Set<OhodnotenieKSPreStudenta> ohodnotenieStudenta) {
        this.ohodnotenieStudenta = ohodnotenieStudenta;
    }
    
    @Override
    public String toString() {
        return (this.getMeno() + " " + this.getPriezvisko());
    }

    public Integer getTypPouzivatela() {
        return typPouzivatela;
    }

    public void setTypPouzivatela(Integer typPouzivatela) {
        this.typPouzivatela = typPouzivatela;
    }

    public Set<SebahodnotenieStudenta> getSebahodnotenie() {
        return sebahodnotenie;
    }

    public void setSebahodnotenie(Set<SebahodnotenieStudenta> sebahodnotenie) {
        this.sebahodnotenie = sebahodnotenie;
    }

    public Set<pedagogHodnotenieStudenta> getPedagogHodnotenie() {
        return pedagogHodnotenie;
    }

    public void setPedagogHodnotenie(Set<pedagogHodnotenieStudenta> pedagogHodnotenie) {
        this.pedagogHodnotenie = pedagogHodnotenie;
    }

    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public Boolean getEmailSuhlas() {
        return emailSuhlas;
    }

    public void setEmailSuhlas(Boolean emainSuhlas) {
        this.emailSuhlas = emainSuhlas;
    }

    public double getSearchResult() {
        return searchResult;
    }

    public void setSearchResult(double searchResult) {
        this.searchResult = searchResult;
    }
    
}
