package entities;

import java.util.HashSet;
import java.util.Set;


/*  
 *  entita, uchovavajuca zakladne informacie o predmete, ktory sa na skole vyucuje. Zoznam predmetov je importovany z externej databazy AIS
*/
public class Predmet {

    /*  
     *  primarny kluc do tabulky
     */
    private Integer id;
    
    /*  
     *  nazov predmetu
     */
    private String nazov; 
    
    /*  
     *  pocet kreditov, ktore moze student ziskat absolvovanim daneho predmetu
     */
    private Integer pocetKreditov;
    
    /*  
     *  odkaz na zoznam klucovych slov, ktore pri ohodnocovani dany predmet ovplyvnuje
     */
    private Set<PredmetKlucoveslovo> cieleOhodnotenia = new HashSet<PredmetKlucoveslovo>(0);

    
    public Predmet() {
    }

    public Predmet(int id, String nazov, Integer pocetKreditov) {
        this.id=id;
        this.setNazov(nazov);
        this.setPocetKreditov(pocetKreditov);
    }
    
    

   
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getNazov() {
        return nazov;
    }

    public void setNazov(String nazov) {
        this.nazov = nazov;
    }

    public Integer getPocetKreditov() {
        return pocetKreditov;
    }

    public void setPocetKreditov(Integer pocetKreditov) {
        this.pocetKreditov = pocetKreditov;
    }

    
    public Set<PredmetKlucoveslovo> getCieleOhodnotenia() {
        return cieleOhodnotenia;
    }

    public void setCieleOhodnotenia(Set<PredmetKlucoveslovo> cieleOhodnotenia) {
        this.cieleOhodnotenia = cieleOhodnotenia;
    }

    @Override
    public String toString() {
        return (this.getNazov());
    }
}
