

package functions;

import persistence.*;
import mains.*;
import entities.*;
import org.hibernate.Transaction;

/**
 *
 * @author My
 * trieda obsahuje metody na tvorbu databaz - databazy Bzz, ktora sa primarne vyuziva v systeme a databazy AIS, ktora tvori extenu databazu akademickeho informacneho systemu.
 */
public class CreateDatabase {
        
    /*
     *  vytvorenie databazy Bzz 
     */
    public void createDBBzz()
    {   //uzvavretie spojenia s databazou (ak je nejake nadviazane)
        Sessions.closeSessinon();
        
        //tvorba tabuliek databazy
        HibernateUtil.createDB();

        //vytvorenie spojenia s databazou
        main.setSession(HibernateUtil.getSessionFactory().openSession());

        //vytvorenie hlavneho klucoveho slova - je nadradene vsetkym klucovym slovam, ale pri ohodnocovani sa nepouziva
        Transaction tx = main.getSession().beginTransaction();
        KlucoveSlovo root = new KlucoveSlovo("root", null);
        main.getSession().save(root);
        tx.commit();
        
        tx = main.getSession().beginTransaction();
        //vytvorenie administratorskeho pristupu do databazy
        Pouzivatel p = new Pouzivatel(1,"admininstrator","administrator","admin","admin",3,"",false);
        main.getSession().save(p);
        tx.commit();

    }
    
    /*
     *  vytvorenie databazy AIS
     */
    public void createDBAis()
    {   //uzavretie spojenia s databazou - ak nejake existuje
        Sessions.closeSessionAIS(); 
        //vytvorenie tabuliek databazy
        HibernateUtilAIS.createDB();
        
    }
}
