
package functions;

import org.hibernate.*;
import java.util.*;
import entities.*;
import entitiesAIS.*;
import mains.*;

/**
 *
 * @author My
 * trieda obsahujuca metody pre vypocet celkovych ohodnoteni klucovych slov studentov
 */
public class EvaluateStudentsRating {

    //urcenie akou vahou vplyva sebahodnotenie klucoveho slova studentom na 
    //ohodnotenie daneho klucoveho slova
    private static double vahaSebahodnotenie = 0.1;
    
    //urcenie akou vahou vplyva ohonotenie studenta pedagogom na ohodnotenie 
    //daneho klucoveho slova
    private static double vahaHodnoteniePedagog = 0.5;

    /*
     *  vypocet celkoveho ohodnotenia klucovych slov
     */
    public void evaluateKeyWords() {
        Iterator itStudents, itHodnotenieStudenta, itKlucoveSlovo, itPredmetKS, itVahy, itOhodnotenia;
        Pouzivatel s;
        KlucoveSlovo ks, rodic;
        Predmet p;
        PredmetKlucoveslovo pks;
        StudentPredmetAIS hod;
        List students, klucoveSlova, predmetKS, hodnotenieStudenta;
        double sum, hodnotenie, vahySuma;
        Transaction t;
        int pocetZdrojov = 0;
        LinkedList<Integer> ohodnotenia;
        LinkedList<Double> vahy;
        
        //zmazanie existujucich ohodnoteni
        vymazOhodnoteniaKS();
        
        //ziskanie zoznamu studentov a zoznamu klucovych slov
        students = main.getSession().createQuery("from Pouzivatel s ").list();
        klucoveSlova = main.getSession().createQuery("from KlucoveSlovo s").list();
        itKlucoveSlovo = klucoveSlova.iterator();
        
        //prechadzame cez vsetky klucove slova a ku kazdemu klucovemu slovu zistime, 
        //ktore predmety na vpyvaju na jeho ohodnotenie
        while(itKlucoveSlovo.hasNext()) {
        
            ks = (entities.KlucoveSlovo) itKlucoveSlovo.next();
            if (ks.getId() == 1) {
                continue;
            }
            
            predmetKS = main.getSession().createQuery("from PredmetKlucoveslovo pks where pks.Ks=" + ks.getId()).list();
            
            //ideme ohodnocovat dane klucove slovo pre kaydeho studenta
            itStudents = students.iterator();
            while (itStudents.hasNext()) {
                pocetZdrojov = 0;
                ohodnotenia = new LinkedList<Integer> ();
                vahy = new LinkedList<Double> ();
                vahySuma=0;
                sum = 0;

                s = (entities.Pouzivatel) itStudents.next();
                
                //prechadzame vsetkymi predmetmi, ktore vplyvaju na klucove slovo
                itPredmetKS = predmetKS.iterator();
                while (itPredmetKS.hasNext()) {

                    pks = (entities.PredmetKlucoveslovo) itPredmetKS.next();
                    p = pks.getPr();
                    
                    //zistime si hodnotenie kazdeho predmetu
                    hodnotenieStudenta = this.importt(s, p);
                    itHodnotenieStudenta = hodnotenieStudenta.iterator();
                    
                    while (itHodnotenieStudenta.hasNext()) {
                        hod = (entitiesAIS.StudentPredmetAIS) itHodnotenieStudenta.next();

                        int znamka=0;
                        //podla znamky, ktoru ziskal priradime hodnotenie
                        if(hod.getZnamka().compareToIgnoreCase("a")==0)
                            znamka=5;
                        else
                            if(hod.getZnamka().compareToIgnoreCase("b")==0)
                                znamka=4;
                            else
                                if(hod.getZnamka().compareToIgnoreCase("c")==0)
                                    znamka=3;
                                else
                                    if(hod.getZnamka().compareToIgnoreCase("d")==0)
                                        znamka=2;
                                    else
                                        if(hod.getZnamka().compareToIgnoreCase("e")==0)
                                            znamka=1;
                        //zapamatame si ciselne ohodnotnenie a vahu, ktorou vplyva predmet 
                        //na klucove slovo
                        ohodnotenia.add(znamka);
                        vahy.add(pks.getVaha());
                    }

                }
                
                itVahy = vahy.iterator();
                //spocitame sucet vsetkych vah. Ked potom podelime kazdu vahu 
                //(ktoru sme si zapamatali) touto sumou, tak sucet tychto podielov bude 1
                while(itVahy.hasNext())
                    vahySuma+=(Double) itVahy.next();
                
                itVahy=vahy.iterator();
                itOhodnotenia=ohodnotenia.iterator();
                
                //spocitame si ohodnotenie klucoveho slova z hodnotenia predmetov
                while(itVahy.hasNext() && itOhodnotenia.hasNext())
                {    sum+=(Integer) itOhodnotenia.next() *(Double) itVahy.next() /vahySuma;
                     pocetZdrojov++;
                }
                //zistime si ako si student ohodnotil dane klucove slovo
                hodnotenie = sebahodnotenie(ks, s);
                //a toto hodnotenie prenasobime prislusnou vahou a pripocitame k zatial vypocitanej sume 
                if(hodnotenie!=0)
                {
                    sum+=hodnotenie*EvaluateStudentsRating.getVahaSebahodnotenie();
                    pocetZdrojov++;
                }
                
                //dalej si zistime priemerne hodnotenia daneho klucoveho slova pre studenta od vsetkych pedagogov 
                //(viac pedagogov mohlo v ramci jedneho klucoveho slova ohodnotit toho isteho studenta, tak vezmeme priemer danych hodnoteni)
                //a pripocitame ho doposial vypocitanemu ohodnoteniu
                hodnotenie = hodnoteniePedagog(ks, s);
                if(hodnotenie!=0)
                {
                    sum+=hodnotenie*EvaluateStudentsRating.getVahaHodnoteniePedagog();
                    pocetZdrojov++;
                }
                
                //ak sme vypocitali nenulove hodnotenie, tak ho zapiseme do databazy
                
                if (sum != 0) {
                    t = main.getSession().beginTransaction();
                    entities.OhodnotenieKSPreStudenta okss = new entities.OhodnotenieKSPreStudenta(sum, s, ks, pocetZdrojov);
                    main.getSession().save(okss);
                    t.commit();
                    
                }
            }
        }
        //teraz mame vypocitane ohodnotenia vsetkych listovych klucovych slov a ideme vypocitat ostatne hodnotenia slov v strome
        Sessions.reopenSession();
        
        //prechadzame cez vsetkych studentov
        itStudents = students.iterator();
        while(itStudents.hasNext())
        {
            s = (Pouzivatel) itStudents.next();
            //zistime si root-ove klucove slovo - vsetky ostatne slova su jeho priamymi alebo nepriamymi nasledovnikmi
            klucoveSlova = main.getSession().createQuery("from KlucoveSlovo s where s.id=1").list();
            itKlucoveSlovo = klucoveSlova.iterator();
            while (itKlucoveSlovo.hasNext()) {
                rodic = (entities.KlucoveSlovo) itKlucoveSlovo.next();
                //ideme ohodnotit vsetkych naslednovnikov root-a
                ohodnotenieKS(rodic, s);

            }
        }
    }

    
    /*
     *  metoda na zistenie hodnotenia studenta z daneho predmetu
     */
    public List importt(Pouzivatel s, Predmet p) {

        //z externej databazy AIS dane hodnotenie zistime
        Transaction tx = main.getSessionAIS().beginTransaction();
        List hodnotenieStudenta = main.getSessionAIS().createQuery("from StudentPredmetAIS hp where hp.pr=" + p.getId() + " and hp.st=" + s.getId()).list();
        tx.commit(); 

        return hodnotenieStudenta;
    }
    
    /*
     *  metoda na ohodnotenie nelistovych klucovych slov
     */
    public double ohodnotenieKS(KlucoveSlovo rodic, Pouzivatel s) {
        List ohodnotenieKSStudenta, vahy;
        Iterator itOhodnotenie, itNasledovnici, itVahy, itOhodnotenieLL, itVahyLL;
        KlucoveSlovo ks;
        Vaha v;
        double sum = 0, ohodnotenie;
        int pocetZdrojov = 0;
        Transaction tx;
        LinkedList<Double> ohodnotenieLL;
        LinkedList<Double> vahyLL;
        double vahySuma, hodnotenie;

        //zistime si zoznam nasledovnikov daneho klucoveho slova
        itNasledovnici = rodic.getNasledovnici().iterator();
        //ak je neprazdny jeho ohodnotenie klucoveho slova vypocitame ako vazeny sucet ohodnoteni jeho priamych nasledovnikov
        if (itNasledovnici.hasNext()) {
            ohodnotenieLL=new LinkedList<Double> ();
            vahyLL = new LinkedList<Double> ();
            vahySuma=0;
            
            //pre kazdeho nasledovnika
            while (itNasledovnici.hasNext()) {
                ks = (entities.KlucoveSlovo) itNasledovnici.next();
                if (ks.getId() == 1) {
                    continue;
                }
                //rekurzivne zistime jeho ohodnotenie
                ohodnotenie = ohodnotenieKS(ks, s);
                
                //zistili sme ohodnotenie nasledovnika, teraz potrebujeme zistit vahu, ktorou prispieva k ohodnoteniu nadredeneho klucoveho slova
                vahy = main.getSession().createQuery("from Vaha v where v.rodic=" + rodic.getId() + " and v.potomok=" + ks.getId()).list();
                
                itVahy = vahy.iterator();
                if (itVahy.hasNext()) {
                    v = (entities.Vaha) itVahy.next();
                    //zapamatame si ohodnotenie daneho nasledovnika a jeho vahu
                    ohodnotenieLL.add(ohodnotenie);
                    vahyLL.add(v.getVaha());
                }
            }
            //tu uz mame ohodnotenia vsetkych nasledovnikov a prislusnych vah
            //ideme si preprojektovat vahy tak, aby ich sucet daval 1 (na to potrebujeme ich sucet)
            itVahyLL=vahyLL.iterator();
            while(itVahyLL.hasNext())
                vahySuma+=(Double) itVahyLL.next();
            
            itVahyLL=vahyLL.iterator();
            itOhodnotenieLL=ohodnotenieLL.iterator();
            //spocitame si vazeny priemer
            while(itVahyLL.hasNext() && itOhodnotenieLL.hasNext())
            {
                sum+=(Double) itVahyLL.next() * (Double) itOhodnotenieLL.next() / vahySuma;
                pocetZdrojov++;
            }
            //pripocitame sebahodnotenie studenta
            hodnotenie = sebahodnotenie(rodic, s);
            if(hodnotenie!=0)
            {
                sum+=hodnotenie*EvaluateStudentsRating.getVahaSebahodnotenie();
                pocetZdrojov++;
            }
            //a priemerne hodnotenie od pedagogov
            hodnotenie = hodnoteniePedagog(rodic, s);
            if(hodnotenie!=0)
            {
                sum+=hodnotenie*EvaluateStudentsRating.getVahaHodnoteniePedagog();
                pocetZdrojov++;
            }
            
            //a ak sme dostali nenulove ohodnotenie tak to zapiseme do databazy
            if (sum != 0) {
                OhodnotenieKSPreStudenta okss = new OhodnotenieKSPreStudenta(sum, s, rodic, pocetZdrojov);
                tx = main.getSession().beginTransaction();
                main.getSession().save(okss);
                tx.commit();
            }
            return sum;
        } else {
            //vetva, ked dane klucove slovo nema ziadnych nasledovnikov
            //zistime z databazy ci ma dane klucove slovo zapisane ohodnotenie - z hodnoteni predmetov
            ohodnotenieKSStudenta = main.getSession().createQuery("from OhodnotenieKSPreStudenta o where o.St=" + s.getId() + "and o.Ks=" + rodic.getId()).list();
            itOhodnotenie = ohodnotenieKSStudenta.iterator();
            if (itOhodnotenie.hasNext()) {
                //ak je take hodnotenie v databaze, tak ho vratime
                return ((entities.OhodnotenieKSPreStudenta) itOhodnotenie.next()).getOhodnotenie();
            } else {
                //inak vratime nulu
                return 0;
            }

        }
    }

    
    /*
     *  metoda na zistenie sebahodnotenia studenta pre klucove slovo
     */
    public int sebahodnotenie(KlucoveSlovo ks, Pouzivatel s) {
        Iterator itSebahodnotenie;
        List sebahodnotenie;
        
        //z databazy zistime hodnotenie a ak take je, tak ho vratime inak vratime nulu
        sebahodnotenie = main.getSession().createQuery("from SebahodnotenieStudenta sh where sh.St=" + s.getId() + " and sh.Ks=" + ks.getId()).list();
        itSebahodnotenie = sebahodnotenie.iterator();
        if (itSebahodnotenie.hasNext()) {
            return ((entities.SebahodnotenieStudenta) itSebahodnotenie.next()).getOhodnotenie();
        } else {
            return 0;
        }
    }

    /*
     *  metoda na zistenie priemerneho hodnotenia studenta pre klucove slovo pedagogmi
     */
    public double hodnoteniePedagog(KlucoveSlovo ks, Pouzivatel s) {
        Iterator itHodnoteniePedagog;
        List hodnoteniePedagog;
        int sum=0;
        int pocet=0;
        
        //z databazy zistime vsetky hodnotenia pedagogom pre daneho studenta v ramci klucoveho slova
        hodnoteniePedagog = main.getSession().createQuery("from pedagogHodnotenieStudenta ph where ph.St=" + s.getId() + " and ph.Ks=" + ks.getId()).list();
        itHodnoteniePedagog = hodnoteniePedagog.iterator();
        while (itHodnoteniePedagog.hasNext()) {
            //spocitame sucet hodnoteni a ich pocet
            sum+= ((pedagogHodnotenieStudenta) itHodnoteniePedagog.next()).getOhodnotenie();
            pocet++;
        } 
        //vratime priemer
        if(pocet!=0)
            return (double) sum / (double) pocet;
        else 
            return 0;
    }
    
    private void vymazOhodnoteniaKS() {
        Transaction tx = main.getSession().beginTransaction();
        List ohodnotenieStudenta = main.getSession().createQuery("from OhodnotenieKSPreStudenta o").list();
        Iterator i = ohodnotenieStudenta.iterator();
        while (i.hasNext()) {
            OhodnotenieKSPreStudenta o = (entities.OhodnotenieKSPreStudenta) i.next();
            main.getSession().delete(o);
        }
        tx.commit();
    }
    
    public static double getVahaHodnoteniePedagog() {
        return vahaHodnoteniePedagog;
    }

    public static void setVahaHodnoteniePedagog(double aVahaHodnoteniePedagog) {
        vahaHodnoteniePedagog = aVahaHodnoteniePedagog;
    }

    public static double getVahaSebahodnotenie() {
        return vahaSebahodnotenie;
    }

    public static void setVahaSebahodnotenie(double aVahaSebahodnotenie) {
        vahaSebahodnotenie = aVahaSebahodnotenie;
    }
}
