
package functions;

import mains.*;
import entities.*;
import entitiesAIS.*; 
import org.hibernate.*;
import java.util.*;
import java.io.*;

/**
 *
 * @author My
 * trieda zabezpecujuca importovanie dat z externej databazy AIS do databazy Bzz
 */
public class Importt {
    
    public static int pocet=0;
    
    /*
     * imporotvanie dat z AIS do Bzz
     */
    public void importFromAIS() {                                         
        Transaction tx = main.getSession().beginTransaction(); 
        //importovanie studentov
        List studentAIS = main.getSessionAIS().createQuery("from PouzivatelAIS s").list();
        Iterator i = studentAIS.iterator();
        while (i.hasNext()) {
            //kazdeho studenta z databazy AIS zapisem do databazy Bzz
            PouzivatelAIS s = (PouzivatelAIS) i.next();
            Pouzivatel sNew = new Pouzivatel(s.getId(), s.getMeno(), s.getPriezvisko(), s.getPriezvisko() + "04", s.getRodneCislo(),1,s.getEmail(),false);
            main.getSession().save(sNew); 
        }
        
        tx = main.getSession().beginTransaction();
        Pouzivatel p = new Pouzivatel(2,"pedagog","pedagog","pedagog","pedagog",2,"",false);
        main.getSession().save(p);
        tx.commit();
        
        tx = main.getSession().beginTransaction();
        p = new Pouzivatel(3,"Anna","Povazanova","Povazanova","anicka",2,"",false);
        main.getSession().save(p);
        tx.commit();
        
        tx = main.getSession().beginTransaction();
        p = new Pouzivatel(4,"Valeria","Simakova","Simakova","valika",2,"",false);
        main.getSession().save(p);
        tx.commit();
        
        tx = main.getSession().beginTransaction();
        p = new Pouzivatel(5,"host","host","guest","guest",4,"",false);
        main.getSession().save(p);
        tx.commit();
        
        //importovanie predmetov z databazy AIS
        tx = main.getSession().beginTransaction();
        List predmetAIS = main.getSessionAIS().createQuery("from PredmetAIS s").list();
        i = predmetAIS.iterator();
        while (i.hasNext()) {
            PredmetAIS pred = (PredmetAIS) i.next();
            Predmet pNew = new Predmet(pred.getId()+1, pred.getNazov(), pred.getKredity());
            main.getSession().save(pNew);
        }
        tx.commit();
        //importovanie klucovych slov, vah medzi klucovymi slovammi a predmetmi a vah medzi klucovymi slovami navzajom
        importPredmetKS("Bzz_rozdelenie.xml");
        System.gc();
    }

    
    /*
     * metoda na importovanie klucovych slov, vah medzi klucovymi slovammi a predmetmi a vah medzi klucovymi slovami navzajom
     */
    public void importPredmetKS(String filename)
	{   String line;
            KlucoveSlovo ks;
            
            Transaction tx;
            
            try{
                //zistim si root-ove klucove slovo
                KlucoveSlovo root = new Read().readRoot();
                //otvorim subor s datami na import
                BufferedReader br = new BufferedReader(new FileReader(filename));
                //citame riadky suboru
                while((line=br.readLine())!=null)
                {   
                    //ak riadok zacina textom "<kategoria" to znamena ze bude nasledovat zoznam klucovych slov, ktore su nalsedovnikmi daneho klucoveho slova
                    if(line.startsWith("<kategoria"))
                    {   //vytvorim si z informacii v riadku <kategoria nove klucove slovo
                        ks = new KlucoveSlovo(line.substring(line.indexOf("nazov=")+7,line.indexOf("\">")),root);
                        tx = main.getSession().beginTransaction();
                        //ulozim ho do databazy
                        main.getSession().save(ks);
                        tx.commit();
//                      //a idem parsovat zvysok klucovych slov pre dane klucove slovo
                        parse(br,"kategoria",ks);
                        
                    }    
                }
                
            }
            catch (IOException e)
            {
                e.printStackTrace();
            }
	}
        /*
         * metoda na parsovanie vstupneho suboru
         * br - vstup zo suboru
         * tag - oznacenie v akom tagu sa nachadzam - dolezite aby som vedel kde mam skoncit, prikladom tagu moze byt "kategoria", "podkategoria", "podpodkategoria"
         * rodic - oznacenie, ake je nadradene klucove slovo
         */
        public double parse(BufferedReader br,String tag, KlucoveSlovo rodic) throws IOException
        {   Transaction tx;
            String line,tagg;
            StringTokenizer st;
            Double vaha=0.0;
            
            //citam v subore dalej
            while((line=br.readLine()).indexOf("</"+tag+">")==-1)
            {   //test, ci sa v riadku nenachadza dalsie vnorenie - nasledovnik klucoveho slova
                //ak tam je, zistime si nazov klucoveho slova a vytvorime objekt a ulozime do databazy
                //potom zavolame rekurzivne tuto funkciu s nizsou urovnou, z nej dostanem aj vahu, ktorou prispieva nasledovnik k ohodnoteniu tohto klucoveho slova a tuto vahu potom ulozim do tabulky Vaha
                if(line.indexOf("<pod"+tag)!=-1)
                {   st=new StringTokenizer(line," ");
                    tagg = st.nextToken();
                    st.nextToken();
//                    
                    KlucoveSlovo ks = new KlucoveSlovo(line.substring(line.indexOf("meno=")+6,line.indexOf("\">")),rodic);
                    tx = main.getSession().beginTransaction();
                    main.getSession().save(ks);
                    tx.commit();
//                    System.out.println("KLUCOVE SLOVO "+ks.getNazov()+" rodic: "+rodic.getNazov());
                    double v = parse(br,tagg.substring(tagg.indexOf("<")+1),ks);
                    tx = main.getSession().beginTransaction();
                    main.getSession().save(new Vaha(v,rodic,ks));
                    tx.commit(); 
                }
                //ak sa v riadku nachadze tag <predmet>, tak to znamena, ze na dane klucove slovo - premenna rodic - vplyva tento predmet
                if(line.indexOf("<predmet>")!=-1)
                {   //zistim si nazov predmetu
                    String predmetName = line.substring(line.indexOf("<predmet>")+new String("<predmet>").length(), line.indexOf("<vaha>"));
                    //vahu, akou vplyva na ohodnotenie klucoveho slova
                    Double v = new Double(line.substring(line.indexOf("<vaha>")+new String("<vaha>").length(),line.indexOf("</vaha>")));
                    //najdem si dany predmet v databaze 
                    List p = main.getSession().createQuery("from Predmet p where p.nazov='"+predmetName+"'").list();
                    Iterator i = p.iterator();
                    if(i.hasNext())
                    {   //ak identifikovany predmet je v databaze, tak vytvorim v databaze vztah predmetu, klucoveho slova s danou vahou
                        tx = main.getSession().beginTransaction();
                        main.getSession().save(new PredmetKlucoveslovo(v,rodic,(entities.Predmet) i.next()));
                        tx.commit();
                    }
                }
                //ak sa v riadku nachadza tag <vaha> a nenachadza sa tam <predmet> tak tento riadok vyjadruje vahu, ktorou prispieva nasledovnik k ohodnoteniu predchodcu - tato hodnota sa vrati ako vysledok celej metody
                if(line.indexOf("<vaha>")!=-1 && line.indexOf("<predmet>")==-1)
                {   
                    vaha = new Double(line.substring(line.indexOf("<vaha>")+new String("<vaha>").length(),line.indexOf("</vaha>")));
//                  
                }
            }
            return vaha;
        }
}
