
package functions;

import entities.KlucoveSlovo;
import entities.Pouzivatel;
import entities.Vaha;
import org.hibernate.*;
import java.util.*;
import mains.*;
        
/**
 *
 * @author My
 * trieda s metodami na nacitavanie dat z databazy
 */
public class Read {
    
    /*
     *  nacitanie vsetkych pouzivatelov, ktori su v databaze
     */
    public List readStudenti()
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamStudentov = main.getSession().createQuery("from Pouzivatel s where s.typPouzivatela=1").list();
        tx.commit();
        System.gc();
        return zoznamStudentov;
    }
    
    /*
     *  nacitanie vah medzi klucovymi slovamk, kde je potomok zadany
     */
    public Vaha readVaha(KlucoveSlovo k)
    {
        Transaction tx = main.getSession().beginTransaction();

        List l = main.getSession().createQuery("from Vaha ks where ks.potomok="+k.getId()).list();

        tx.commit();
        System.gc();
        Iterator i=l.iterator();
        if(i.hasNext())
            return (Vaha) i.next();
        else
            return null;
        
    }
    
    /*
     *  nacitanie vsetkych predmetov (a prislusnych vah), ktore ovplyvnuju dane klucove slovo
     */
    public List readPredmetKlucoveSlovo(KlucoveSlovo k)
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamOhodnoteni = main.getSession().createQuery("from PredmetKlucoveslovo pks where pks.Ks="+k.getId()).list();
        tx.commit();
        System.gc();
        return zoznamOhodnoteni;
    }
    
    /*
     *  vstupom je meno pouzivatela v tvare "priezvisko, meno" a vystupom je objekt pouzivatela s danym menom
     */
    public Pouzivatel readPouzivatelFromMeno(String meno)
    {   String krstne,priezvisko;
        
        StringTokenizer st = new StringTokenizer(meno,",");
        if(st.countTokens()<1 || st.countTokens()>2)
            return null;
        if(st.countTokens()==2)
        {
            priezvisko=st.nextToken();
            krstne=(st.nextToken()).trim();
            
        }
        else 
        {
            priezvisko=st.nextToken();
            krstne="";        
        }
        Transaction tx = main.getSession().beginTransaction();
        List l = main.getSession().createQuery("from Pouzivatel p where p.meno='"+krstne+"' and p.priezvisko='"+priezvisko+"'").list();
        tx.commit();
        System.gc();
        Iterator i=l.iterator();
        if(i.hasNext())
            return (Pouzivatel) i.next();
        else
            return null;
    }

    /*
     *  nacitanie vsetkych vyucujucich
     */
    public List readVyuc()
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamVyuc = main.getSession().createQuery("from Pouzivatel s where s.typPouzivatela=2").list();
        tx.commit();
        System.gc();
        return zoznamVyuc;
    }
    
    /*
     *  nacitanie vsetkych guestov - hosti
     */
    public List readHostia()
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamHosti = main.getSession().createQuery("from Pouzivatel s where s.typPouzivatela=4").list();
        tx.commit();
        System.gc();
        return zoznamHosti;
    }
    
    /*
     *  nacitanie vsetkych sebahodnoteni, ktore si student zadal
     */
    public List readKlucoveSlovaStudenta(Pouzivatel p)
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamKS = main.getSession().createQuery("from SebahodnotenieStudenta ks where ks.St="+p.getId()).list();
        tx.commit();
        System.gc();
        return zoznamKS;
    }
    
    /*
     *  nacitanie vsetkych hodnoteni od daneho predagoga pre daneho studenta 
     */
    public List readVyucHodPreStudenta(Pouzivatel p, Pouzivatel pedagog)
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamKS = main.getSession().createQuery("from pedagogHodnotenieStudenta ks where ks.St="+p.getId()+" and ks.Pedagog="+pedagog.getId()).list();
        tx.commit();
        System.gc();
        return zoznamKS;
    }
    
    /*
     *  zistenie root-oveho klucoveho slova
     */
    public KlucoveSlovo readRoot()
    {
        Transaction tx = main.getSession().beginTransaction();
        List zoznamKS = main.getSession().createQuery("from KlucoveSlovo ks where ks.id=1").list();
        tx.commit();
        System.gc();
        Iterator i = zoznamKS.iterator();
        if(i.hasNext())
        {
            return (KlucoveSlovo) i.next();
        }
        return null;
    }
}
