
package functions;

import entities.*;
import java.util.*;
import mains.*;
import org.hibernate.*;
import org.hibernate.criterion.Expression;

/**
 *
 * @author My
 * trieda na vyhladavanie v studentoch podla hodnotenia klucovych slov
 */
public class Search {

    public List<Pouzivatel> search(LinkedList<String> ks, LinkedList<Integer> priority) {
        int index;
        int sum=0;
        LinkedList<Double> projectedPriority = new LinkedList<Double> ();
        OhodnotenieKSPreStudenta o;

        //preprojektovanie priorit aby ich sucet daval 1
        Iterator i = priority.iterator();
        while(i.hasNext())
        {
            sum+=(Integer) i.next();
        }
        
        i=priority.iterator();
        while(i.hasNext())
        {
            Integer d = (Integer) i.next();
            projectedPriority.add((double)d/ (double)sum);
        }
        
        Transaction tx;
        tx = main.getSession().beginTransaction();
        //nacitanie vsetkych ohodnoteni studentov, ktori maju ohodnotene take klucove slovo, 
        //ktore sa nachadza v zozname kluvoych slov podla ktorych vyhladavame
        //a zaroven typ pouzivatela musi byt 1 - student
        Criteria c = main.getSession().createCriteria(OhodnotenieKSPreStudenta.class);
        c.createCriteria("Ks").add(Expression.in("nazov", ks));
        c.createCriteria("St").add(Expression.eq("typPouzivatela", 1));

        List ll = c.list();

        tx.commit();

        i = ll.iterator();
        //vymazanie predoslych vysledkov hladania
        while(i.hasNext())
        {
            ((OhodnotenieKSPreStudenta) i.next()).getSt().setSearchResult(0);
        }
        i = ll.iterator();
        //kazdemu studentovi vypocitam jeho rating v ramci daneho hladania (priorita hladania * ohodnotenie klucoveho slova)
        while (i.hasNext()) {
            o = (OhodnotenieKSPreStudenta) i.next();
            index = ks.indexOf(o.getKs().getNazov());
            o.getSt().setSearchResult(o.getSt().getSearchResult() + o.getOhodnotenie() * projectedPriority.get(index));
        }
        //usporiadanie zoznamu podla vypocitaneho ratingu studentov
        Collections.sort(ll, new OhodnotenieComparator());

        i=ll.iterator();
        //prepis zoznamu do zoznamu studentov a zaroven vyhodenie duplicitnych zaznamov studentov
        LinkedList<Pouzivatel> result = new LinkedList<Pouzivatel> ();
        if(i.hasNext())
        {   Pouzivatel pom1;
            Pouzivatel pom= ((OhodnotenieKSPreStudenta) i.next()).getSt();
            
            result.add(pom);
            while(i.hasNext())        
            {   pom1=((OhodnotenieKSPreStudenta) i.next()).getSt();
                if(pom1.getId()!=pom.getId())
                    result.add(pom1);
                pom=pom1;
            }
        }
        System.gc();
        return result;
    }

    class OhodnotenieComparator implements Comparator {

        public int compare(Object emp1, Object emp2) {

//parameter are of type Object, so we have to downcast it to Employee objects

            Double val1 = ((entities.OhodnotenieKSPreStudenta) emp1).getSt().getSearchResult();

            Double val2 = ((entities.OhodnotenieKSPreStudenta) emp2).getSt().getSearchResult();

            //return emp1Name.compareToIgnoreCase(emp2Name);
            if(val1>val2)
                return -1;
            else
                if(val1==val2)
                    return 0;
                else
                    return 1;
        }
    }
}
