
package functions;

import org.hibernate.*;
import entities.*;
import mains.*;
import java.util.*;

/**
 *
 * @author My
 * trieda na zapis udajov do databazy
 */
public class Write {

    /**
      * aktualizacia profilu pouzivatela - umoznuje aj zmenu typu pouzivatela - dostupre pre administratorov
      */
    public boolean UpdateProfil(Pouzivatel p, String meno, String priezvisko, String login, String heslo, String typPouzivatela) {
        try
        {   p.setLogin(login);
            p.setPasswd(heslo);
            p.setPriezvisko(priezvisko);
            p.setMeno(meno);
            p.setTypPouzivatela(new Integer(typPouzivatela));
            main.getSession().update(p);
            System.gc();
            return true;
        }
        catch (Exception e)
        {       return false;
        }
    }
    
    
    /**
      *  aktualizacia profilu pouzivatela - neumoznuje zmenu typu pouzivatela
      */
    public boolean UpdateProfilUzivatel(Pouzivatel p, String email, Boolean suhlas, String heslo) {
        p.setEmail(email);
        p.setEmailSuhlas(suhlas);
        p.setPasswd(heslo);
        main.getSession().update(p);
        System.gc();
        return true;
    }
    
    /**
      * aktualizavia vahy medzi dvoma klucovymi slovami
      */
    public void saveVaha(Vaha v,  String newHodnota)
    {   Transaction tx = main.getSession().beginTransaction();
        v.setVaha(new Double(newHodnota));
        main.getSession().save(v);
        tx.commit();
        System.gc();
    }
    
    
    /**
      * aktualizacia vahy medzi predmetom a klucovym slovom
      */
    public void saveVahaPredmetKS(PredmetKlucoveslovo pks,  String newHodnota)
    {  Transaction tx = main.getSession(). beginTransaction();
        pks.setVaha(new Double(newHodnota));
        main.getSession().save(pks);
        tx.commit();
        System.gc();
    }
    
    /**
      * ulozenie sebahodnotenia studenta
      */
    public boolean writeSebahodnotenie(Pouzivatel p, String ks, String ohodnotenie) {
        Integer hodnota = new Integer(ohodnotenie);
        //zistujeme ktore klucove slovo ohodnocuje
        List l = main.getSession().createQuery("from KlucoveSlovo ks where ks.nazov='" + ks + "'").list();
        Iterator i = l.iterator();
        if (i.hasNext()) {
            //ak existuje (nenastala nejaka chyba, nic sa nezmenilo)
            KlucoveSlovo k = (KlucoveSlovo) i.next();
            Transaction tx = main.getSession().beginTransaction();
            //tak zistim ci uz ma aj samohodnotenie pre dane klucove slovo
            List ll = main.getSession().createQuery("from SebahodnotenieStudenta s where s.Ks=" + k.getId() + " and s.St=" + p.getId()).list();
            Iterator ii = ll.iterator();
            if (ii.hasNext()) {
                //ak ma sebahodnotenie, tak najdem dane ohodnotenie klucoveho slova 
                SebahodnotenieStudenta s = (SebahodnotenieStudenta) ii.next();
                List lll = main.getSession().createQuery("from OhodnotenieKSPreStudenta o where o.Ks="+k.getId()+" and o.St="+p.getId()).list();
                Iterator iii = lll.iterator();
                if(iii.hasNext())
                {   //nasiel som dane sebahodnotenie, teraz odcitam stare seabdohnotenie a pripocitam nove sebahodnotenie a ulozim do DB
                    OhodnotenieKSPreStudenta o = ((OhodnotenieKSPreStudenta) iii.next());
                    o.setOhodnotenie(o.getOhodnotenie()+(-s.getOhodnotenie()+hodnota)*EvaluateStudentsRating.getVahaSebahodnotenie());
                    main.getSession().update(o);
                }
                else{
                    //ak neexistuje ohodnotenie, tak ulozim nove
                    main.getSession().save(new OhodnotenieKSPreStudenta(hodnota*EvaluateStudentsRating.getVahaSebahodnotenie(),p,k,1));
                }
                //ulozim samotne sebahodnotenie
                s.setOhodnotenie(hodnota);
                main.getSession().update(s);
            } else {
                //ak si student dane klucove slovo este neohodnotil
                //tak sa pozriem ci uz ma dane klucove slovo ohodnotene
                List lll = main.getSession().createQuery("from OhodnotenieKSPreStudenta o where o.Ks="+k.getId()+" and o.St="+p.getId()).list();
                Iterator iii = lll.iterator();
                if(iii.hasNext())
                {   //ak je ohodnotene, tak pripocitam sebahodnotenie
                    OhodnotenieKSPreStudenta o = ((OhodnotenieKSPreStudenta) iii.next());
                    o.setOhodnotenie(o.getOhodnotenie()+EvaluateStudentsRating.getVahaSebahodnotenie()*hodnota);
                    o.setPocetZdrojov(o.getPocetZdrojov()+1);
                    main.getSession().update(o);
                }
                else
                {   //ak nie je ohodnotene, tak vytvorim node ohodnotenie
                    main.getSession().save(new OhodnotenieKSPreStudenta(hodnota*EvaluateStudentsRating.getVahaSebahodnotenie(),p,k,1));
                }
                //ulozim samotne sebahodnotenie
                main.getSession().save(new SebahodnotenieStudenta(hodnota, p, k));
            }

            tx.commit();
            System.gc();
            return true;
        } else {
            System.gc();
            return false;
        }
    }

    
    /**
      * ulozenie hodnotenia studenta pedagogom
      */
    public boolean writePedagogHodnotenie(Pouzivatel p, String ks, String ohodnotenie, Pouzivatel pedagog) {
        Integer hodnota = new Integer(ohodnotenie);
        int sum=0, pocet=0;
        pedagogHodnotenieStudenta phs,phsPedagoga=null;
        //zistime ktoremu klucovemu slovu patri dane hodnotenie
        List l = main.getSession().createQuery("from KlucoveSlovo ks where ks.nazov='" + ks + "'").list();
        Iterator i = l.iterator();
        if (i.hasNext()) {
            KlucoveSlovo k = (KlucoveSlovo) i.next();
            Transaction tx = main.getSession().beginTransaction();
            //zistim ci uz dany student mal hodnotene klucove slovo nejakym pedagogom
            List ll = main.getSession().createQuery("from pedagogHodnotenieStudenta s where s.Ks=" + k.getId() + "and s.St=" + p.getId()).list();
            Iterator ii = ll.iterator();
            if(ii.hasNext())
            {   //ak ma take hodnotenia vypocitam si sucet vsetkych a ich pocet (lebo k ohodnoteniu klucoveho slova prispievaju priemernou hodnotou)
                while(ii.hasNext())
                {   
                    phs=(pedagogHodnotenieStudenta) ii.next();
                    if(phs.getPedagog().getId()==pedagog.getId())
                        phsPedagoga=phs;
                    sum+=phs.getOhodnotenie();
                    pocet++;
                }
                //zistim ci je uz ohodnotene klucove slovo
                List lll=main.getSession().createQuery("from OhodnotenieKSPreStudenta o where o.Ks="+k.getId()+" and o.St="+p.getId()).list();
                Iterator iii = lll.iterator();
                if(iii.hasNext())
                {   //ak ano tak k z jeho ohodnotenia odpocitam staru hodnotu a pripocitam movu
                    OhodnotenieKSPreStudenta o = (OhodnotenieKSPreStudenta) iii.next();
                    if(phsPedagoga!=null)
                    {
                        o.setOhodnotenie(o.getOhodnotenie()+((double) (-phsPedagoga.getOhodnotenie()+hodnota)/ (double)pocet)*EvaluateStudentsRating.getVahaHodnoteniePedagog());
                    }
                    else
                    {
                        o.setOhodnotenie(o.getOhodnotenie()-((double) sum / (double) pocet)*EvaluateStudentsRating.getVahaHodnoteniePedagog());
                        o.setOhodnotenie(o.getOhodnotenie()+((double)(sum+hodnota)/(double)(pocet+1))*EvaluateStudentsRating.getVahaHodnoteniePedagog());
                        o.setPocetZdrojov(o.getPocetZdrojov()+1);
                    }
                    main.getSession().save(o); 
                }
                else
                {   
                    main.getSession().save(new OhodnotenieKSPreStudenta((sum+hodnota)/(pocet+1)*EvaluateStudentsRating.getVahaHodnoteniePedagog(),p,k,1));

                }
                if(phsPedagoga!=null)
                {   //ak hodnotil aktualny pedagogo, treba dany zaznam aktualizovat
                    phsPedagoga.setOhodnotenie(hodnota);
                    main.getSession().save(phsPedagoga);
                }
                else
                    //inak vytvorim novy zaznam
                    main.getSession().save(new pedagogHodnotenieStudenta(hodnota,p,k,pedagog));
            }
            else
            {   //ak student este nebol v ramci daneho klucoveho slova hodnoteny pedagogom
                //zistim ci uz ma ohodnotenie daneho klucoveho slova
                List lll=main.getSession().createQuery("from OhodnotenieKSPreStudenta o where o.Ks="+k.getId()+" and o.St="+p.getId()).list();
                Iterator iii = lll.iterator();
                if(iii.hasNext())
                {   //ak hej, tak pripocitam hodnotenie od pedagoga
                    OhodnotenieKSPreStudenta o = (OhodnotenieKSPreStudenta) iii.next();
                    o.setOhodnotenie(o.getOhodnotenie()+hodnota*EvaluateStudentsRating.getVahaHodnoteniePedagog());
                    o.setPocetZdrojov(o.getPocetZdrojov()+1);
                    main.getSession().save(o);
                }
                else
                {   //ak nie, vytvorim nove ohodnotenie
                    main.getSession().save(new OhodnotenieKSPreStudenta(hodnota*EvaluateStudentsRating.getVahaHodnoteniePedagog(),p,k,1));
                }
                main.getSession().save(new pedagogHodnotenieStudenta(hodnota,p,k,pedagog));
            }

            tx.commit();
            System.gc();
            return true;
        } else {
            System.gc();
            return false;
        }
    }
}
