package persistence; 

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.tool.hbm2ddl.SchemaExport;

public class HibernateUtil {
    
    private static SessionFactory sessionFactory;
    private static Configuration cfg;
    private static SchemaExport s;
    
    static {
        cfg = new Configuration();
        //cfg.configure("hibernatex.cfg.xml");
        cfg.configure();
    }
    
    public static void buildSessionFactory() {
        try {
            sessionFactory = cfg.buildSessionFactory();
        } catch (Throwable ex) {
            throw new ExceptionInInitializerError(ex);
        }
    }
    
    public static void createDB() {
        s = new SchemaExport(cfg);
        s.create(true, true);
    }
    
    public static SessionFactory getSessionFactory() {
        buildSessionFactory();
        return sessionFactory;
    }
    
    public static void shutdown() {
        if(getSessionFactory()!=null && !getSessionFactory().isClosed())
            getSessionFactory().close();
    }
}
