package persistence; 

import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
import org.hibernate.tool.hbm2ddl.SchemaExport;

public class HibernateUtilAIS {
    
    private static SessionFactory sessionFactoryAIS;
    private static Configuration cfgAIS;
    private static SchemaExport sAIS;
    
    static {
        cfgAIS = new Configuration();
        cfgAIS.configure("hibernateAIS.cfg.xml");
    }
    
    public static void buildSessionFactory() {
        try {
            sessionFactoryAIS = cfgAIS.buildSessionFactory();
        } catch (Throwable ex) {
            throw new ExceptionInInitializerError(ex);
        }
    }
    
    public static void createDB() {
        sAIS = new SchemaExport(cfgAIS);
        sAIS.create(true, true);
    }
    
    public static SessionFactory getSessionFactory() {
        buildSessionFactory();
        return sessionFactoryAIS;
    }
    
    public static void shutdown() {
        if(getSessionFactory()!=null && !getSessionFactory().isClosed())
            getSessionFactory().close();
    }
}
